import { QueryOrderKeys, QueryOrderMap, FilterQuery } from '@mikro-orm/core';

type CursorState<T extends object> = [string, QueryOrderKeys<T>, any][];
declare class Cursor<T extends object> {
    readonly state: CursorState<T>;
    private constructor();
    static fromEntity<T extends object>(entity: T, orderBy: QueryOrderMap<T> | QueryOrderMap<T>[]): Cursor<T>;
    static fromBase64<T extends object>(base64: string): Cursor<T>;
    toBase64(): string;
    toJSON(): string;
    buildOrderBy({ direction }: {
        direction: 'forward' | 'backward';
    }): QueryOrderMap<T>;
    buildWhereOr({ direction }: {
        direction: 'forward' | 'backward';
    }): FilterQuery<T>[];
}

export { Cursor };
